/*
   Try examples like
      >java ParseURL  http://math.purduecal.edu:80/~rlkraft/cs40400/class.html#Sept26
      >java ParseURL  http://www.google.com:80
*/
import java.net.*;

public class ParseURL
{
   public static void main(String[] args) throws Exception
   {
      URL url = null;
      if (args.length > 0)
      {
         url = new URL( args[0] );
      }
      else
      {  // Cretae a default URL.
         url = new URL("ftp://username:password@example.com:8042/over/there/index.dtb?type=animal&name=narwhal#nose");
      }

      // See
      //     http://en.wikipedia.org/wiki/URI_scheme#Examples
      System.out.println( "URI = " + url.toURI() );
      System.out.println();
      System.out.println( "Protocol = "  + url.getProtocol() );
      System.out.println( "Authority = " + url.getAuthority() );
      System.out.println( "UserInfor = " + url.getUserInfo() );
      System.out.println( "Host = "      + url.getHost() );
      System.out.println( "Port = "      + url.getPort() );
      System.out.println( "Path = "      + url.getPath() );
      System.out.println( "File = "      + url.getFile() );
      System.out.println( "Query = "     + url.getQuery() );
      System.out.println( "Anchor = "    + url.getRef() );
   }
}