/*
   Try examples like
      >java RetrieveHTTPURL  math.purduecal.edu/~rlkraft/
      >java RetrieveHTTPURL  www.google.com
*/
import java.net.*;
import java.io.*;

public class RetrieveHTTPURL
{
   public static void main(String[] args) throws Exception
   {
      URL url = null;
      if (args.length > 0)
      {
         url = new URL( "http://" + args[0] );  // always use HTTP
      }
      else
      {
         System.err.println("Usage: java RetrieveHTTPURL <url>");
         System.exit(1);
      }
      InputStream in = url.openStream();
      BufferedReader bf = new BufferedReader( new InputStreamReader(in, "latin1") );

      String oneLine;
      while ( (oneLine = bf.readLine()) != null )
      {
         System.out.println(oneLine);
      }
   }
}