/*
   A simple HTTP client.

   This program has hard coded into it
   the URL that it is supposed to get.
*/
import java.net.*;  // for Socket
import java.io.*;   // for IOException and InputStream, OutputStream

public class HTTPClient_v2
{
   public static void main(String[] args) throws IOException
   {
      // Set the server name (or IP address).
      String server = "www.nytimes.com";
      // Set the port number.
      int servPort = 80;

      // Set the message.
      String message = "GET / HTTP/1.1\nhost:www.nytimes.com\n\n";


      // Create a Socket object that is connected to server on specified port.
      Socket socket = new Socket(server, servPort);
      System.out.println("Connected to server...sending request\n");

      // Get (low-level) input and output streams from the socket.
      InputStream in = socket.getInputStream();
      OutputStream out = socket.getOutputStream();

      // Convert the message String to bytes using the default character encoding
      byte[] requestBuffer = message.getBytes();
      out.write(requestBuffer);  // Send the encoded string to the server

      // Receive the response from the server (including the "response headers").
      byte[] reponseBuffer = new byte[220000];
      int totalBytesRcvd = 0;  // Total bytes received so far
      int bytesRcvd;           // Bytes received in last read
      int counter = 0;  // count how many read() requests we need to make
      boolean done = false;
      while (!done && totalBytesRcvd < reponseBuffer.length)
      {
         if (-1 == (bytesRcvd = in.read(reponseBuffer,
                                        totalBytesRcvd,
                                        reponseBuffer.length - totalBytesRcvd)))
         {
            done = true;
         }
         else
         {
            totalBytesRcvd += bytesRcvd;
            counter++;
         }
      }

      // Send the response to standard output.
      System.out.println( new String(reponseBuffer) );

      socket.close();  // Close the socket and its streams

      System.out.println( "connection closed: counter = " + counter );
   }
}