/*
   adderPOST.c - a minimal CGI program that adds two numbers together

   NOTE: For a cgi process, standard output has been redirected to a socket.
         So printf() in this process will be sending data over a socket!
         What if the other end of the socket is closed prematurely? Then
         printf() could generate a SIGPIPE signal. Or printf() could
         return with an EPIPE error (or error numbers 104 or 113). For a
         simple cgi process, it is probably OK to just let the process die.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define  MAXLINE   8192  /* max text line length */

int main(void)
{
   char *len, *p;
   char buf[MAXLINE], arg1[MAXLINE], arg2[MAXLINE], content[MAXLINE];
   int n1=0, n2=0;
   int length=-1, i = 0;

   /* Extract the two arguments from QUERY_STRING */
   if ((len = getenv("CONTENT_LENGTH")) != NULL)
   {
      length = atoi(len);
      for (i = 0; i < length; i++)
         buf[i] = getchar();  /* read from stdin */
      buf[length] = 0;        /* null terminate the input string */

      p = strchr(buf, '&');
      *p = '\0';
      strcpy(arg1, buf);
      strcpy(arg2, p+1);
      *p = '&';

      p = strchr(arg1, '=');
      n1 = atoi(++p);

      p = strchr(arg2, '=');
      n2 = atoi(++p);
   }

   /* Make the response body */
   sprintf(content, "Welcome to add.com: ");
   sprintf(content, "%sthe Internet addition portal.\n\n<p>", content);
   sprintf(content, "%sEnvironment variable CONTENT_LENGTH = %d\n<p>", content, length);
   sprintf(content, "%sThe entity body from the POST method was [%s]\n\n<p>", content, buf);
   sprintf(content, "%sThe answer is: %d + %d = %d\n<p>", content, n1, n2, n1 + n2);
   sprintf(content, "%sThanks for visiting!\n", content);

   /* Send the HTTP response headers */
   printf("Content-type: text/html\n");
   printf("Content-length: %d\n", strlen(content));
   printf("\n");

   /* Send the response body */
   printf("%s", content);
   fflush(stdout);

   exit(0);
}