/*
   adderAjaxGet.c - a minimal CGI program that adds two numbers together

   This program handles two kinds of URLs.
   The HTML form type URL with key=value, e.g.,
      cgi-bin/adderAjaxGET.exe?x=5&y=9
   And a non standard type of URL that only has values, e.g.,
      cgi-bin/adderAjaxGET.exe?5&9
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define  MAXLINE   8192  /* max text line length */

int main(void)
{
   char *buf, *p;
   char arg1[MAXLINE], arg2[MAXLINE], content[MAXLINE];
   int n1=0, n2=0;

   /* Extract the two arguments from QUERY_STRING */
   if ((buf = getenv("QUERY_STRING")) != NULL)
   {
      p = strchr(buf, '&');
      *p = '\0';
      strcpy(arg1, buf);
      strcpy(arg2, p+1);
      *p = '&';

      p = strchr(arg1, '=');
      if (!p)
      {
         n1 = atoi(arg1);
      }
      else  // the URL is of the form key=value
      {
         n1 = atoi(++p);
      }

      p = strchr(arg2, '=');
      if (!p)
      {
         n2 = atoi(arg2);
      }
      else  // the URL is of the form key=value
      {
         n2 = atoi(++p);
      }
   }

   /* Make the response body */
   sprintf(content, "%d", n1 + n2);

   /* Send the HTTP response headers */
   printf("Content-type: text/html\n");
   printf("Content-length: %d\n", strlen(content));
   printf("\n");

   /* Send the response body */
   printf("%s", content);
   fflush(stdout);

   exit(0);
}